; SketchyLISP Extension Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; depth

; ---conformance---
; SketchyLISP Extension

; ---purpose---
; Compute the depth of a list. The depth
; of a list is the maximum number of nested
; lists enclosing any atom of the list.
; The depth of an atom is 0.

; ---args---
; A - list

; ---keywords---
; DEPTH function, list, member, depth, size

; ---see-also---
; count, length

; ---example---
; (depth '(a b (c (d) e) ((f)))) => 3

; (require "lib/fold-left.scm")
; (require "lib/max.scm")
; (require "lib/map.scm")
; (require "lib/plus.scm") ; +

; ---code---
(define (depth a)
  (cond ((pair? a)
      (+ 1 (fold-left max 0 (map depth a))))
    (else 0)))
