; SketchyLISP Extension Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; head?

; ---conformance---
; SketchyLISP Extension

; ---purpose---
; Check whether an expression is the head of another.

; ---args---
; X - potential head
; Y - expression

; ---keywords---
; HEAD? function, list, pair, head

; ---see-also---
; tail?, last

; ---example---
; (head? '(a b c) '(a b c d e f)) => #t

; (require "nullp.scm") ; null?
; (require "lib/equalp.scm") ; equal?

; ---code---
(define (head? x y)
  (cond ((null? y) (null? x))
    ((null? x) #t)
    ((equal? (car x) (car y))
      (head? (cdr x) (cdr y)))
    (else #f)))
