; SketchyLISP Extension Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; remq

; ---conformance---
; R5.91RS

; ---purpose---
; Remove symbols from lists.

; ---args---
; X - symbol to remove
; A - list

; ---keywords---
; REMQ function, lists, sets, set theory, member, remove

; ---see-also---
; remove, remv, memq

; ---example---
; (remq 'z '(x y z x y z)) => (x y x y)

(define remq #t)

; (require "nullp.scm") ; null?
; (require "lib/not.scm")
(require "filter.scm")

; ---model---
; (define (remv x a)
;   (cond ((null? a) '())
;     ((eqv? x (car a)) (cdr a))
;     (else (cons (car a) (remove x (cdr a))))))

; ---code---
(define (remq x a)
  (filter (lambda (y)
            (not (eq? x y)))
          a))
