; SketchyLISP Extension Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; substitute

; ---conformance---
; SketchyLISP Extension

; ---purpose---
; Substitute variables in forms.

; ---args---
; X - form to process
; A - association list

; ---keywords---
; SUBSTITUTE function, substitution, substitute variables
; association lists

; ---see-also---
; replace

; ---example---
; (substitute '(i + ii - iii) '((i . 1) (ii . 2) (iii . 3))) => (1 + 2 - 3)

; (require "nullp.scm") ; null?
; (require "lib/assoc.scm")
; (require "lib/reverse.scm")
; (require "lib/caar.scm") ; cdar
; (require "lib/append.scm")

; ---code---
(define (substitute x a)
  (let ((v (assoc x a)))
    (cond (v (cdr v))
      ((pair? x)
        (cons (substitute (car x) a)
              (substitute (cdr x) a)))
      (else x))))
