; SketchyLISP Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; char-alphabetic?

; ---conformance---
; R5RS

; ---purpose---
; Test whether a char is alphabetic.

; ---args---
; X - char

; ---keywords---
; CHAR-ALPHABETIC? function, chars, characters, property, case

; ---see-also---
; char-lower-case?, char-numeric?, char-whitespace?

; ---example---
; (char-alphabetic? #\c) => #t

(define c-alphabeticp #t)

(require "c-upper-casep.scm") ; char-upper-case?
(require "c-lower-casep.scm") ; char-lower-case?

; ---code---
(define (char-alphabetic? x)
  (or (char-lower-case? x)
      (char-upper-case? x)))
