; SketchyLISP Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; char-ci<=?

; ---conformance---
; R5RS

; ---purpose---
; Case-insensitively test whether a sequence of chars is in
; lexically non-descending order.

; ---args---
; X - char
; Y... - chars

; ---keywords---
; CHAR-CI<=? function, chars, characters, comparison,
; lexical order, non-descending, case insensitive

; ---see-also---
; char<=?, char-ci<?, char-ci=?, char-ci>?, char-ci>=?, string<=?, equal?

; ---example---
; (char-ci<=? #\b #\B #\c) => #t

(define c-cilep #t)

; (require "pred-iter.scm") ; predicate-iterator
; (load "c-downcase.scm") ; char-downcase
; (load "lteq.scm") ; <=

; ---model---
; (define char-ci<=?
;   (predicate-iterator
;     (lambda (x y)
;       (<= (char->integer (char-downcase x))
;           (char->integer (char-downcase y))))))

; ---code---
; This function is a primitive function.
