; SketchyLISP Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; even?

; ---conformance---
; R5RS

; ---purpose---
; Test whether a number is even.

; ---args---
; X - number

; ---keywords---
; EVEN? function, even, odd, numbers, digit, predicate

; ---see-also---
; digits, odd?, zero?

; ---example---
; (even? 2) => #t

(define evenp #t)

(require "digits.scm")
(require "reverse.scm")
(require "memq.scm")
; (require "zerop.scm") ; zero?
; (require "remainder.scm")

; ---model---
; (define (even? x)
;   (zero? (remainder x 2)))

; ---code---
(define (even? x)
  (and (memq (car (reverse (integer->list x)))
             (integer->list 02468))
       #t))
