; SketchyLISP Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; lcm

; ---conformance---
; R5RS

; ---purpose---
; Compute the least common multiple of a sequence of numbers.

; ---args---
; A... - numbers

; ---keywords---
; LCM function, lcm, least common multiple, arithmetics

; ---see-also---
; digits, expt, gcd

; ---example---
; (lcm 32 -36) => 288

(define lcm #t)

(require "abs.scm")
(require "gcd.scm")
(require "nquotient.scm")
(require "ntimes.scm") ; n*
(require "natural.scm")
(require "fold-left.scm")

; ---code---
(define (lcm . a)
  (letrec
    ((_lcm
       (lambda (a b)
         (let ((cd (gcd a b)))
           (n* cd (n* (nquotient a cd)
                      (nquotient b cd)))))))
    (fold-left _lcm 1 (map (lambda (x)
                             (natural (abs x)))
                      a))))
