; SketchyLISP Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; nremainder

; ---conformance---
; SketchyLISP Core

; ---purpose---
; Compute the division remainder of two natural numbers.

; ---args---
; A - natural number (dividend)
; B - natural number (divisor)

; ---keywords---
; NREMAINDER function, division, remainder, division remainder
; modulus, arithmetics, natural

; ---see-also---
; digits, ndivide, nquotient, n*, n+, n-, remainder

; ---example---
; (nremainder 11 4) => 3

(define nremainder #t)

(require "ndivide.scm")
(require "caar.scm") ; cadr

; ---code---
(define (nremainder a b)
  (cadr (ndivide a b)))
