; SketchyLISP Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; string=?

; ---conformance---
; R5RS

; ---purpose---
; Test whether all strings in a sequence are equal.

; ---args---
; X - string
; Y... - strings

; ---keywords---
; STRING=? function, strings, comparison, equivalence,
; lexical equivalence

; ---see-also---
; string-ci=?, string<?, string>?, string<=?, string>=?, char=?, equal?

; ---example---
; (string=? "xyz" "xyz" "xyz") => #t

(define seqp #t)

(load "equalp.scm") ; equal?
(require "pred-iter.scm") ; predicate-iterator

; ---code---
(define string=?
  (predicate-iterator
    (lambda (x y)
      (equal? (string->list x)
              (string->list y)))))
