; SketchyLISP Example Program
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; bubblesort

; ---purpose---
; Sort a list using the bubblesort algorithm.

; ---language---
; R5RS Scheme + SketchyLISP Ext.

; ---args---
; X - list to sort
; P - predicate defining the desired order

; ---keywords---
; BUBBLESORT function, bubble sort, sorting, example

; ---example---
; (bubblesort < '(5 1 3 2 4)) => (1 2 3 4 5)

; (require "lib/caar.scm") ; cadr cddr

; ---code---
(require "orderedp.scm") ; ordered?

(define (bubblesort p x)
  (letrec
    ((bubble-up
       (lambda (x)
         (cond ((null? x) '())
           ((null? (cdr x)) x)
           ((p (car x) (cadr x))
             (cons (car x) (bubble-up (cdr x))))
           (else (cons (cadr x)
                   (bubble-up (cons (car x)
                                    (cddr x))))))))
     (bubble-step
       (lambda (x)
         (cond ((ordered? p x) x)
           (else (bubble-step (bubble-up x)))))))
    (bubble-step x)))
